精华内容
下载资源
问答
  • Java中throw、throws和Throwable的联系与区别

    throw,意为“投掷、抛、扔”。Throw、Throws和Throwable三者都用于异常处理。

    1. Throwable

    Throwable在Java中是异常处理这个分支的顶级父类,其它所有异常处理的实现都依赖于Throwable

    打开Java官方文档(Java8版本),找到Throwable,它的直接子类为ErrorException

    image-20211212145310021

    Error和Exception两者的特点在于Error异常程序无法处理,只能交由人工介入修改代码,比如栈溢出、堆溢出等等;而Exception异常可以提前发觉,并作出有效处理。

    1.1 扩展-Error

    在Error中,常见的有栈溢出和堆溢出等等。

    image-20211212151054845

    举个例子,StackOverflowError

    public class ErrorTest {
        public static void main(String[] args) {
            main(args);
        }
    }
    

    无限递归,执行这个程序就会报栈溢出异常。

    image-20211212151352974

    再比如堆异常,OutOfMemoryError

    public class ErrorTest {
        public static void main(String[] args) {
            Integer[] testArray = new Integer[1024*1024*1024];
        }
    }
    

    image-20211212151542228

    1.2 扩展-Exception

    在Exception中就有非常多我们所熟知的异常情况了,比如NullPointerException(空指针异常)、ArrayIndexOutOfBoundsException(数组下标越界)、NumberFormatException(数字格式化异常)等等。

    public class ExceptionTest {
        public static void main(String[] args) {
            int[] testArray = null;
            System.out.println(testArray[0]);  //空指针异常
        }
    }
    
    public class ExceptionTest {
        public static void main(String[] args) {
            int[] testArray = new int[3];
            System.out.println(testArray[3]);   //数组下标越界
        }
    }
    
    public class ExceptionTest {
        public static void main(String[] args) {
            String num = "abc";
            System.out.println(Integer.parseInt(num));    //数字格式化异常
        }
    }
    

    2. throws

    throws应用在方法声明处,指明此方法在执行时可能会出现的异常类型。一旦该方法执行时出现异常,就会在异常代码处生成一个异常类的对象,此对象满足Throws后的异常类型时,就会被抛出。(这里有两个过程,代码有异常时,1.生成一个异常对象;2. throws捕获到这个异常,将异常对象抛出

    throws和try-catch-finally一起称为异常处理的两种方式。

    try-catch-finally是在出现异常时主动处理掉异常,使得程序可以继续执行下去;而throws捕获到异常之后向上抛出异常对象,不去真正地处理这个异常。

    所谓向上抛出异常对象,是将异常对象交给调用者去处理,比如方法A调用方法B,B通过throws抛出异常,而A可以选择使用try-catch-finally处理掉异常,也可以通过throws继续向上抛出异常对象,直到异常被真正处理掉。如果一直没有方法去处理异常,异常对象最终会被抛给JVM,从而导致程序停止运行。

    @Test
    public void throwsTest(){   //调用者解决抛出的异常
        try{
            formatChange("abc");
        }
        catch (NumberFormatException e){
            System.out.println("转换格式错误!");
        }
        catch (Exception e){
            System.out.println("出现错误");
        }
    }
    
    private int formatChange(String str) throws NumberFormatException{    //出现异常向上抛出
        return Integer.parseInt(str);
    }
    

    2.1 扩展-如何选择try-catch-finally还是throws?

    当一个方法中存在异常需要处理,在大多数情况下,既可以选择try-catch-finally直接处理掉这个异常,也可以选择throws向上抛出异常,交给调用者去处理(异常抛到最后,总要有一方真正地去处理这个异常,怎么处理?还是用try-catch-finally呗),在选择上比较自由,但是,出现以下两种情况时,需要遵循一定的规则(如有补充,敬请指出)。

    • 如果父类中被重写的方法没有使用throws抛出异常,则子类重写的方法也不能使用throws抛出异常,也就意味着这种情况必须使用try-catch-finally去处理。
    • 在方法A中,先后调用了另外的几种方法,这几种方法是递进关系执行的且其中很多方法都存在异常需要处理,这种情况建议被调用的几个方法使用throws向上抛出异常,在方法A中,使用try-catch-finally统一处理掉这些异常。

    针对第一条,这是一个规定,子类中重写的方法使用throws抛出的异常必须不大于父类中被重写的方法抛出异常的范围。举个例子,父类中的方法B抛出NullPointerException异常,则子类中重写B方法就不能抛出如Exception这种比NullPointerException范围更大的异常;如果父类中被重写的方法没有抛出任何异常,则子类更不能抛出异常。

    为什么?展示一段代码。

    //假设父类中的方法B抛出NullPointerException异常,子类中的方法B可以抛出Exception
    
    private void test(ParentClassTest parent){
        try{
            parent.B();
        }
        catch(NullPointerException e){
            System.out.println("出现了空指针异常");
        }
    }
    

    在本示例中,假设父类中的方法B抛出NullPointerException异常,子类中重写的方法B可以抛出Exception。那么传进给test方法的参数如果是父类的实例化对象,那么调用test方法没有任何问题。如果传进的参数是子类的实例化对象,再去调用子类重写的方法B,那么就有可能抛出Exception异常,try-catch结构就压不住这个异常了,这显然是一个不合理的操作。

    针对第二条,假设方法A中调用了方法C、D、E,这三个方法都有可能产生异常,且存在递进关系,也就是D、E执行需要C执行完成、E执行依赖C、D执行完成。那么就推荐在C、D、E中向上抛出异常,在方法A中集中处理。为什么?如果C、D、E都是向上抛出异常,而A使用try-catch-finally去处理这个异常,如果某个方法真的出现异常,则不再继续执行。而如果C、D、E都使用try-catch-finally直接解决掉异常,那么即使产生了异常,方法A也不会接收到异常的产生,那么还会接着往下执行,但是C出现了异常,再执行D、E没有任何意义。

    3. throw

    如果在程序编写时有手动抛出异常的需求,则可以使用throw

    throw使用在方法体内。与try-catch-finally和throws都不同,异常处理的两个阶段:1.遇到异常,生成异常对象;2.捕获到异常,进行抛出或处理。try-catch-finally和throws都处在第二个阶段,都是捕获到异常后的相关处理,一般使用系统根据异常类型自动生成的异常对象进行处理。而throw应用在第一阶段,手动地产生一个异常对象。

    举一个例子,判断一个数值是否为非负数,如果为负数,则抛出异常。

    class ThrowTest{
    
        private int Number;
    
        public void judge(int num){
            if(num>=0){
                this.Number = num;
            }
            else{
                throw new RuntimeException("传入参数为负数");
            }
        }
    }
    
    @Test
    public void test2(){
        ThrowTest throwTest = new ThrowTest();
        throwTest.judge(-100);
    }
    

    成功抛出异常。

    image-20211213001848290

    使用try-catch捕获一下异常。

    @Test
    public void test2(){
        ThrowTest throwTest = new ThrowTest();
        try{
            throwTest.judge(-100);
        }
        catch (RuntimeException e){
            System.out.println(e.getMessage());
        }
    }
    

    image-20211213002119033

    如果把throw抛出的异常改为Exception,则直接报错,也就是不能编译。Exception包含两种异常:编译时异常和运行时异常,前者在编译前就要检查是否有可能产生编译时异常;后者是在编译后运行时才会判断的异常。而throw new Exception包含了编译时异常,需要显式处理掉这个异常,怎么处理?try-catch-finally或者throws

    image-20211213002417836

    class ThrowTest{
    
        private int Number;
    
        public void judge(int num) throws Exception{
            if(num>=0){
                this.Number = num;
            }
            else{
                throw new Exception("传入参数为负数");
            }
        }
    }
    

    调用方也要随着进行更改。

    @Test
    public void test2(){
        ThrowTest throwTest = new ThrowTest();
        try{
            throwTest.judge(-100);
        }
        catch (RuntimeException e){
            System.out.println(e.getMessage());
        }
        catch (Exception e){
            System.out.println(e.getMessage());
        }
    }
    

    image-20211213002930580

    3.1 扩展-自定义异常类

    throw还可以抛出自定义异常类。

    自定义异常类的声明需要继承于现有的异常体系。

    class MyException extends RuntimeException{
        static final long serialVersionUID = -703489719076939L;   //可以认为是一种标识
    
        public MyException(){}
    
        public MyException(String message){
            super(message);
        }
    }
    

    此时我们可以抛出自定义的异常

    class ThrowTest{
    
        private int Number;
    
        public void judge(int num) throws MyException{
            if(num>=0){
                this.Number = num;
            }
            else{
                throw new MyException("不能输入负数");
            }
        }
    }
    

    调用者修改

    @Test
    public void test2(){
        ThrowTest throwTest = new ThrowTest();
        try{
            throwTest.judge(-100);
        }
        catch (MyException e){
            System.out.println(e.getMessage());
        }
    }
    

    image-20211213004438453

    4. 总结

    三者共同点在于都属于是异常处理的范畴内。

    不同点:

    • Throwable是异常处理这个分支的顶层父类,其它异常类的实现都需要继承于Throwable

    • throw应用在方法体内,是生成异常对象的一种方式

    • throws应用在方法声明处,声明出可能要抛出的各种异常类,是处理异常的方式

    展开全文
  • java中throws的使用问题

    2021-03-04 05:27:14
    在执行该方法期间,无需在方法中通过throws声明可能抛出但没有捕获的 Error 的任何子类,因为Java编译器不去检查它,也就是说,当程序中可能出现这类异常时,即使没有用try...catch语句捕获它,也没有用throws字句...

    展开全部

    异常处理是32313133353236313431303231363533e58685e5aeb931333236383437程序设计中一个非常重要的方面,也是程序设计的一大难点,从C开始,你也许已经知道如何用if...else...来控制异常了,也许是自发的,然而这种控制异常痛苦,同一个异常或者错误如果多个地方出现,那么你每个地方都要做相同处理,感觉相当的麻烦! Java语言在设计的当初就考虑到这些问题,提出异常处理的框架的方案,所有的异常都可以用一个类型来表示,不同类型的异常对应不同的子类异常(这里的异常包括错误概念),定义异常处理的规范,在1.4版本以后增加了异常链机制,从而便于跟踪异常!这是Java语言设计者的高明之处,也是Java语言中的一个难点,下面是我对Java异常知识的一个总结,也算是资源回收一下。

    一、Java异常的基础知识

    异常是程序中的一些错误,但并不是所有的错误都是异常,并且错误有时候是可以避免的。比如说,你的代码少了一个分号,那么运行出来结果是提示是错误java.lang.Error;如果你用System.out.println(11/0),那么你是因为你用0做了除数,会抛出java.lang.ArithmeticException的异常。

    有些异常需要做处理,有些则不需要捕获处理,后面会详细讲到。

    天有不测风云,人有旦夕祸福,Java的程序代码也如此。在编程过程中,首先应当尽可能去避免错误和异常发生,对于不可避免、不可预测的情况则在考虑异常发生时如何处理。

    Java中的异常用对象来表示。Java对异常的处理是按异常分类处理的,不同异常有不同的分类,每种异常都对应一个类型(class),每个异常都对应一个异常(类的)对象。

    异常类从哪里来?有两个来源,一是Java语言本身定义的一些基本异常类型,二是用户通过继承Exception类或者其子类自己定义的异常。Exception 类及其子类是 Throwable 的一种形式,它指出了合理的应用程序想要捕获的条件。

    异常的对象从哪里来呢?有两个来源,一是Java运行时环境自动抛出系统生成的异常,而不管你是否愿意捕获和处理,它总要被抛出!比如除数为0的异常。二是程序员自己抛出的异常,这个异常可以是程序员自己定义的,也可以是Java语言中定义的,用throw 关键字抛出异常,这种异常常用来向调用者汇报异常的一些信息。

    异常是针对方法来说的,抛出、声明抛出、捕获和处理异常都是在方法中进行的。

    Java异常处理通过5个关键字try、catch、throw、throws、finally进行管理。基本过程是用try语句块包住要监视的语句,如果在try语句块内出现异常,则异常会被抛出,你的代码在catch语句块中可以捕获到这个异常并做处理;还有以部分系统生成的异常在Java运行时自动抛出。你也可以通过throws关键字在方法上声明该方法要抛出异常,然后在方法内部通过throw抛出异常对象。finally语句块会在方法执行return之前执行,一般结构如下:

    try{

    程序代码

    }catch(异常类型1 异常的变量名1){

    程序代码

    }catch(异常类型2 异常的变量名2){

    程序代码

    }finally{

    程序代码

    }

    catch语句可以有多个,用来匹配多个异常,匹配上多个中一个后,执行catch语句块时候仅仅执行匹配上的异常。catch的类型是Java语言中定义的或者程序员自己定义的,表示代码抛出异常的类型,异常的变量名表示抛出异常的对象的引用,如果catch捕获并匹配上了该异常,那么就可以直接用这个异常变量名,此时该异常变量名指向所匹配的异常,并且在catch代码块中可以直接引用。这一点非常非常的特殊和重要!

    Java异常处理的目的是提高程序的健壮性,你可以在catch和finally代码块中给程序一个修正机会,使得程序不因异常而终止或者流程发生以外的改变。同时,通过获取Java异常信息,也为程序的开发维护提供了方便,一般通过异常信息就很快就能找到出现异常的问题(代码)所在。

    Java异常处理是Java语言的一大特色,也是个难点,掌握异常处理可以让写的代码更健壮和易于维护。

    二、Java异常类类图

    下面是这几个类的层次图:

    java.lang.Object

    java.lang.Throwable

    java.lang.Exception

    java.lang.RuntimeException

    java.lang.Error

    java.lang.ThreadDeath

    下面四个类的介绍来自java api 文档。

    1、Throwable

    Throwable 类是 Java 语言中所有错误或异常的超类。只有当对象是此类(或其子类之一)的实例时,才能通过 Java 虚拟机或者 Java throw 语句抛出。类似地,只有此类或其子类之一才可以是 catch 子句中的参数类型。

    两个子类的实例,Error 和 Exception,通常用于指示发生了异常情况。通常,这些实例是在异常情况的上下文中新近创建的,因此包含了相关的信息(比如堆栈跟踪数据)。

    2、Exception

    Exception 类及其子类是 Throwable 的一种形式,它指出了合理的应用程序想要捕获的条件,表示程序本身可以处理的异常。

    3、Error

    Error 是 Throwable 的子类,表示仅靠程序本身无法恢复的严重错误,用于指示合理的应用程序不应该试图捕获的严重问题。

    在执行该方法期间,无需在方法中通过throws声明可能抛出但没有捕获的 Error 的任何子类,因为Java编译器不去检查它,也就是说,当程序中可能出现这类异常时,即使没有用try...catch语句捕获它,也没有用throws字句声明抛出它,还是会编译通过。

    4、RuntimeException

    RuntimeException 是那些可能在 Java 虚拟机正常运行期间抛出的异常的超类。Java编译器不去检查它,也就是说,当程序中可能出现这类异常时,即使没有用try...catch语句捕获它,也没有用throws字句声明抛出它,还是会编译通过,这种异常可以通过改进代码实现来避免。

    5、ThreadDeath

    调用 Thread 类中带有零参数的 stop 方法时,受害线程将抛出一个 ThreadDeath 实例。

    仅当应用程序在被异步终止后必须清除时才应该捕获这个类的实例。如果 ThreadDeath 被一个方法捕获,那么将它重新抛出非常重要,因为这样才能让该线程真正终止。

    如果没有捕获 ThreadDeath,则顶级错误处理程序不会输出消息。

    虽然 ThreadDeath 类是“正常出现”的,但它只能是 Error 的子类而不是 Exception 的子类,因为许多应用程序捕获所有出现的 Exception,然后又将其放弃。

    以上是对有关异常API的一个简单介绍,用法都很简单,关键在于理解异常处理的原理,具体用法参看Java API文档。

    三、Java异常处理机制

    对于可能出现异常的代码,有两种处理办法:

    第一、在方法中用try...catch语句捕获并处理异常,catach语句可以有多个,用来匹配多个异常。例如:

    public void p(int x){

    try{

    ...

    }catch(Exception e){

    ...

    }finally{

    ...

    }

    }

    第二、对于处理不了的异常或者要转型的异常,在方法的声明处通过throws语句抛出异常。例如:

    public void test1() throws MyException{

    ...

    if(....){

    throw new MyException();

    }

    }

    如果每个方法都是简单的抛出异常,那么在方法调用方法的多层嵌套调用中,Java虚拟机会从出现异常的方法代码块中往回找,直到找到处理该异常的代码块为止。然后将异常交给相应的catch语句处理。如果Java虚拟机追溯到方法调用栈最底部main()方法时,如果仍然没有找到处理异常的代码块,将按照下面的步骤处理:

    第一、调用异常的对象的printStackTrace()方法,打印方法调用栈的异常信息。

    第二、如果出现异常的线程为主线程,则整个程序运行终止;如果非主线程,则终止该线程,其他线程继续运行。

    通过分析思考可以看出,越早处理异常消耗的资源和时间越小,产生影响的范围也越小。因此,不要把自己能处理的异常也抛给调用者。

    还有一点,不可忽视:finally语句在任何情况下都必须执行的代码,这样可以保证一些在任何情况下都必须执行代码的可靠性。比如,在数据库查询异常的时候,应该释放JDBC连接等等。finally语句先于return语句执行,而不论其先后位置,也不管是否try块出现异常。finally语句唯一不被执行的情况是方法执行了System.exit()方法。System.exit()的作用是终止当前正在运行的 Java 虚拟机。finally语句块中不能通过给变量赋新值来改变return的返回值,也建议不要在finally块中使用return语句,没有意义还容易导致错误。

    最后还应该注意一下异常处理的语法规则:

    第一、try语句不能单独存在,可以和catch、finally组成 try...catch...finally、try...catch、try...finally三种结构,catch语句可以有一个或多个,finally语句最多一个,try、catch、finally这三个关键字均不能单独使用。

    第二、try、catch、finally三个代码块中变量的作用域分别独立而不能相互访问。如果要在三个块中都可以访问,则需要将变量定义到这些块的外面。

    第三、多个catch块时候,Java虚拟机会匹配其中一个异常类或其子类,就执行这个catch块,而不会再执行别的catch块。

    第四、throw语句后不允许有紧跟其他语句,因为这些没有机会执行。

    第五、如果一个方法调用了另外一个声明抛出异常的方法,那么这个方法要么处理异常,要么声明抛出。

    那怎么判断一个方法可能会出现异常呢?一般来说,方法声明的时候用了throws语句,方法中有throw语句,方法调用的方法声明有throws关键字。

    throw和throws关键字的区别

    throw用来抛出一个异常,在方法体内。语法格式为:throw 异常对象。

    throws用来声明方法可能会抛出什么异常,在方法名后,语法格式为:throws 异常类型1,异常类型2...异常类型n。

    四、如何定义和使用异常类

    1、使用已有的异常类,假如为IOException、SQLException。

    try{

    程序代码

    }catch(IOException ioe){

    程序代码

    }catch(SQLException sqle){

    程序代码

    }finally{

    程序代码

    }

    2、自定义异常类

    创建Exception或者RuntimeException的子类即可得到一个自定义的异常类。例如:

    public class MyException extends Exception{

    public MyException(){}

    public MyException(String smg){

    super(smg);

    }

    }

    3、使用自定义的异常

    用throws声明方法可能抛出自定义的异常,并用throw语句在适当的地方抛出自定义的异常。例如:

    在某种条件抛出异常

    public void test1() throws MyException{

    ...

    if(....){

    throw new MyException();

    }

    }

    将异常转型(也叫转译),使得异常更易读易于理解

    public void test2() throws MyException{

    ...

    try{

    ...

    }catch(SQLException e){

    ...

    throw new MyException();

    }

    }

    还有一个代码,很有意思:

    public void test2() throws MyException{

    ...

    try {

    ...

    } catch (MyException e) {

    throw e;

    }

    }

    这段代码实际上捕获了异常,然后又和盘托出,没有一点意义,如果这样还有什么好处理的,不处理就行了,直接在方法前用throws声明抛出不就得了。异常的捕获就要做一些有意义的处理。

    五、运行时异常和受检查异常

    Exception类可以分为两种:运行时异常和受检查异常。

    1、运行时异常

    RuntimeException类及其子类都被称为运行时异常,这种异常的特点是Java编译器不去检查它,也就是说,当程序中可能出现这类异常时,即使没有用try...catch语句捕获它,也没有用throws字句声明抛出它,还是会编译通过。例如,当除数为零时,就会抛出java.lang.ArithmeticException异常。

    2、受检查异常

    除了RuntimeException类及其子类外,其他的Exception类及其子类都属于受检查异常,这种异常的特点是要么用try...catch捕获处理,要么用throws语句声明抛出,否则编译不会通过。

    3、两者的区别

    运行时异常表示无法让程序恢复运行的异常,导致这种异常的原因通常是由于执行了错误的操作。一旦出现错误,建议让程序终止。

    受检查异常表示程序可以处理的异常。如果抛出异常的方法本身不处理或者不能处理它,那么方法的调用者就必须去处理该异常,否则调用会出错,连编译也无法通过。当然,这两种异常都是可以通过程序来捕获并处理的,比如除数为零的运行时异常:

    public class HelloWorld {

    public static void main(String[] args) {

    System.out.println("Hello World!!!");

    try{

    System.out.println(1/0);

    }catch(ArithmeticException e){

    System.out.println("除数为0!");

    }

    System.out.println("除数为零后程序没有终止啊,呵呵!!!");

    }

    }

    运行结果:

    Hello World!!!

    除数为0!

    除数为零后程序没有终止啊,呵呵!!!

    4、运行时错误

    Error类及其子类表示运行时错误,通常是由Java虚拟机抛出的,JDK中与定义了一些错误类,比如VirtualMachineError

    和OutOfMemoryError,程序本身无法修复这些错误.一般不去扩展Error类来创建用户自定义的错误类。而RuntimeException类表示程序代码中的错误,是可扩展的,用户可以创建特定运行时异常类。

    Error(运行时错误)和运行时异常的相同之处是:Java编译器都不去检查它们,当程序运行时出现它们,都会终止运行。

    5、最佳解决方案

    对于运行时异常,我们不要用try...catch来捕获处理,而是在程序开发调试阶段,尽量去避免这种异常,一旦发现该异常,正确的做法就会改进程序设计的代码和实现方式,修改程序中的错误,从而避免这种异常。捕获并处理运行时异常是好的解决办法,因为可以通过改进代码实现来避免该种异常的发生。

    对于受检查异常,没说的,老老实实去按照异常处理的方法去处理,要么用try...catch捕获并解决,要么用throws抛出!

    对于Error(运行时错误),不需要在程序中做任何处理,出现问题后,应该在程序在外的地方找问题,然后解决。

    六、异常转型和异常链

    异常转型在上面已经提到过了,实际上就是捕获到异常后,将异常以新的类型的异常再抛出,这样做一般为了异常的信息更直观!比如:

    public void run() throws MyException{

    ...

    try{

    ...

    }catch(IOException e){

    ...

    throw new MyException();

    }finally{

    ...

    }

    }

    异常链,在JDK1.4以后版本中,Throwable类支持异常链机制。Throwable 包含了其线程创建时线程执行堆栈的快照。它还包含了给出有关错误更多信息的消息字符串。最后,它还可以包含 cause(原因):另一个导致此 throwable 抛出的 throwable。它也称为异常链 设施,因为 cause 自身也会有 cause,依此类推,就形成了异常链,每个异常都是由另一个异常引起的。

    通俗的说,异常链就是把原始的异常包装为新的异常类,并在新的异常类中封装了原始异常类,这样做的目的在于找到异常的根本原因。

    通过Throwable的两个构造方法可以创建自定义的包含异常原因的异常类型:

    Throwable(String message, Throwable cause)

    构造一个带指定详细消息和 cause 的新 throwable。

    Throwable(Throwable cause)

    构造一个带指定 cause 和 (cause==null ? null :cause.toString())(它通常包含类和 cause 的详细消息)的详细消息的新 throwable。

    getCause()

    返回此 throwable 的 cause;如果 cause 不存在或未知,则返回 null。

    initCause(Throwable cause)

    将此 throwable 的 cause 初始化为指定值。

    在Throwable的子类Exception中,也有类似的指定异常原因的构造方法:

    Exception(String message, Throwable cause)

    构造带指定详细消息和原因的新异常。

    Exception(Throwable cause)

    根据指定的原因和 (cause==null ? null : cause.toString()) 的详细消息构造新异常(它通常包含 cause 的类和详细消息)。

    因此,可以通过扩展Exception类来构造带有异常原因的新的异常类。

    七、Java异常处理的原则和技巧

    1、避免过大的try块,不要把不会出现异常的代码放到try块里面,尽量保持一个try块对应一个或多个异常。

    2、细化异常的类型,不要不管什么类型的异常都写成Excetpion。

    3、catch块尽量保持一个块捕获一类异常,不要忽略捕获的异常,捕获到后要么处理,要么转译,要么重新抛出新类型的异常。

    4、不要把自己能处理的异常抛给别人。

    5、不要用try...catch参与控制程序流程,异常控制的根本目的是处理程序的非正常情况。

    2Q==

    已赞过

    已踩过<

    你对这个回答的评价是?

    评论

    收起

    展开全文
  • 2.处理异常说到处理异常,我们当然会想到 trycatchfinally在java中我们会对异常的处理有更高的认识 我们会学习throwthrows等更好的处理异常3.常见异常4.throw关键字:语句抛出异常 throws关键字:声明异常(方法抛出...

    1.首先我们来了解什么是异常呢?

    异常阻止当前方法或作用域继续执行的问题。

    2.处理异常

    说到处理异常,我们当然会想到 try catch finally

    在java中我们会对异常的处理有更高的认识 我们会学习 throw throws等更好的处理异常

    3.常见异常

    0516cc850387de9cd74e75e2bcf2c645.png

    4.throw关键字:语句抛出异常   throws关键字:声明异常(方法抛出一个异常)

    01.throw   是语句抛出一个异常。

    语法:throw (异常对象);

    throw e;

    02. throws  是方法可能抛出异常的声明。(用在声明方法时,表示该方法可能要抛出异常)   调用者必须做出处理(捕获或继续抛出)

    语法:[(修饰符)](返回值类型)(方法名)([参数列表])[throws(异常类)]{......}

    public void doA(int a) throws Exception1,Exception3{......}

    03.throws可以单独使用,但throw不能, throw要么和try-catch-finally语句配套使用,要么与throws配套使用。但throws可以单独使 用,然后再由处理异常的方法捕获。

    04.throw语句用在方法体内,表示抛出异常,由方法体内的语句处理

    throws语句用在方法声明后面,表示再抛出异常,由调用这个方法的上一级方法中的语句来处理,必须做出处理(捕获或继续声明)

    05.throws主要是声明这个方法会抛出这种类型的异常,使其他地方调用它时知道要捕获这个异常,使得提醒必须做出处理。否则编译是不会通过的。

    throw是具体向外抛异常的动作,所以它是抛出一个异常实例。

    eg:

    public void dothing(int a,int b) throws Exception1,Exception3 {

    try{

    //......

    }catch(Exception1 e){

    throw e;

    }catch(Exception2 e){

    System.out.println("自己打印提示,不抛出");

    }

    if(a!=b)

    throw new Exception3("自定义异常");

    }

    代码块中可能会产生3个异常,(Exception1,Exception2,Exception3)。

    如果产生Exception1异常,则捕获之后再抛出,由该方法的调用者去处理。

    如果产生Exception2异常,则该方法自己处理了(即打印出字符串:自己打印提示,不抛出)。所以该方法就不会再向外抛出Exception2异常了,void dothing() throws Exception1,Exception3 里面的Exception2也就不用写了(当然你写了也不会报错的),throws 就是声明可能抛出的错误,而Exception2 并未做出抛出操作。

    而Exception3异常是该方法的某段逻辑出错,程序员自己做了处理,在该段逻辑错误的情况下抛出异常Exception3,则该方法的调用者也要处理此异常。

    Java中 try--catch-- finally、throw、throws 的用法

    一.try {..} catch {..}finally {..}用法 try { 执行的代码,其中可能有异常.一旦发现异常,则立即跳到catch执行.否则不会执行catch里面的内容 } catch ...

    【Java心得总结二】浅谈Java中的异常

    作为一个面向对象编程的程序员对于 下面的一句一定非常熟悉: try { // 代码块 } catch(Exception e) { // 异常处理 } finally { // 清理工作 } 就是面向 ...

    Java中的异常-Throwable-Error-Exception-RuntimeExcetpion-throw-throws-try catch

    今天在做一个将String转换为Integer的功能时,发现Integer.parseInte()会抛出异常NumberFormatException. 函数Integer.parseInt(Stri ...

    Java中的异常详解

    一.异常定义 阻止当前方法或作用域继续执行的问题,称为异常 二.异常分析      所有不正常类都继承Throwable类,这个类主要有两个子类Error类和Exception类.Error指系统错误 ...

    Java中的异常和处理详解

    简介 程序运行时,发生的不被期望的事件,它阻止了程序按照程序员的预期正常执行,这就是异常.异常发生时,是任程序自生自灭,立刻退出终止,还是输出错误给用户?或者用C语言风格:用函数返回值作为执行状态?. ...

    Java中的异常简介

    Java中异常的分类 Java中的异常机制是针对正常运行程序的一个必要补充,一般来说没有加入异常机制,程序也能正常运营,但是,由于入参.程序逻辑的严谨度,总会有期望之外的结果生成,因此加入异常机制的补 ...

    Java 中的异常

    前段时间集合的整理真的是给我搞得心力交瘁啊,现在可以整理一些稍微简单一点的,搭配学习 ~ 突然想到一个问题,这些东西我之前就整理过,现在再次整理有什么区别嘛?我就自问自答一下,可能我再次整理会看到不一 ...

    Java 中的异常和处理详解

    Java 中的异常和处理详解 原文出处: 代码钢琴家 简介 程序运行时,发生的不被期望的事件,它阻止了程序按照程序员的预期正常执行,这就是异常.异常发生时,是任程序自生自灭,立刻退出终止,还是输出错误 ...

    Java 中的异常和处理详解&lpar;转载&rpar;

    原文出处: 代码钢琴家 简介 程序运行时,发生的不被期望的事件,它阻止了程序按照程序员的预期正常执行,这就是异常.异常发生时,是任程序自生自灭,立刻退出终止,还是输出错误给用户?或者用C语言风格:用函 ...

    随机推荐

    CHARINDEX

    实现查询条件多个值的或的关系 Select Id,Name from CustTable where CharIndex( CustTable.Name, 'ACDE,BEX,CCC')>0 C ...

    MySQL的Order By Rand&lpar;&rpar;的效率问题

    MySQL很多时候需要获取随机数据,举个例子,要从tablename表中随机提取一条记录,大家一般的写法就是: 但是,后来我查了一下MYSQL的官方手册,里面针对RAND()的提示大概意思就是,在OR ...

    iOS 开发知识小集(1)

    iOS 开发知识小集(1) 2015-05-15  iOS大全 (点击上方蓝字,快速关注我们) 一直想做这样一个小册子,来记录自己平时开发.阅读博客.看书.代码分析和与人交流中遇到的各种问题.之前有过 ...

    基于Linux的oracle数据库管理 part3&lpar; 存储 网络 常用命令 &rpar;

    主要内容 1. 常用存储模式 2. 配置网络 3. 维护指令 常用存储模式 - 文件系统 优点:管理方便, 缺点:读写慢 - 裸设备 只没有被格式化和挂载的磁盘, 只能有程序直接访问, 不能被操作系统 ...

    观察者模式:关于通知的使用(NSNotificationCenter)

    一.通知的使用方法 1.发出通知 例如:[[NSNotificationCenter defaultCenter]postNotificationName:@"backToFirstPage ...

    JS 函数调用

    Js函数调用的方式有如下几种情况: (1)具名函数直接调用 function foo() { } foo(); (2)匿名函数通过引用来调用 fooRef = function() { } fooRe ...

    C&num;与C&plus;&plus;相比较之STL篇

    引言 Program into Your Language, Not in It--.如何深入一门语言去编程?我认为有三步:熟悉它:知道它的局限性:扩展它.如何熟悉?不必说,自 ...

    SR4000笔记

    长时间运行情况下需要有降温处理(40度以下) 建议使用触发模式而非连续模式 850nm波长的光(虽然无害,建议不要直视) 12V DC 滤波镜头(允许24个LED激光波长的通过) 快闪:获取数据 慢闪 ...

    实现硬件PWM控制电机旋转和通过编码器计算所转圈数的简单例程

    该例程所用的硬件设备: 直流电机驱动模块YYH-LWZ: H桥 大功率 正反转 刹车 PWM 调速 5/12/24V 12V直流减速电机JGB37-520B:ASLONG JGB37-520B编码器减 ...

    部署一个不依赖tomcat容器的应用

    一个task项目,应用里边都是一些定时任务.我和新入职的高开商定程序部署不依赖于tomcat. 计划赶不上变化,任务开发完成还没等上线呢,哥们要离职了.工作交接时大概说了一下上线怎么部署. 结果呢,当 ...

    展开全文
  • Java throws 使用

    2021-02-12 11:10:25
    针对这种情况,Java总允许在方法的后面使用throws关键字对外声明该方法有可能发生异常,这样调用者在调用方法时,就明确地知道该方法有异常,并且必须在程序中对异常进行处理,否则编译无法通过。如下面代码package ...

    在开发中,如果去调用别人写的方法时,是否能知道别人写的方法是否会发生异常?这是很难判断的。针对这种情况,Java总允许在方法的后面使用throws关键字对外声明该方法有可能发生异常,这样调用者在调用方法时,就明确地知道该方法有异常,并且必须在程序中对异常进行处理,否则编译无法通过。

    如下面代码

    package www.kangxg.jdbc;

    public class Example {

    public static void main(String[] args) {

    // TODO Auto-generated method stub

    int result = divide(4,2);

    System.out.println(result);

    }

    public static int divide(int x,int y) throws Exception

    {

    int result = x/y;

    return result;

    }

    }

    这时候 编译器上会有错误提示  Unhandled exception type Exception

    所以需要对调用divide()方法进行try...catch处理

    package www.kangxg.jdbc;

    public class Example {

    public static void main(String[] args) {

    try {

    int    result = divide(4,2);

    System.out.println(result);

    } catch (Exception e) {

    e.printStackTrace();

    }

    }

    public static int divide(int x,int y) throws Exception

    {

    int result = x/y;

    return result;

    }

    }

    debug 运行程序

    当 调用divide()方法时,如果不知道如何处理声明抛出的异常,也可以使用throws 关键字继续抛异常,这样程序也能编译运行。但是注意的是,程序一旦发生异常,如果没有被处理,程序就会非正常终止。如下:

    package www.kangxg.jdbc;

    public class Example {

    public static void main(String[] args) throws Exception {

    int    result = divide(4,0);

    System.out.println(result);

    }

    public static int divide(int x,int y) throws Exception

    {

    int result = x/y;

    return result;

    }

    }

    debug运行程序

    Java 运行时异常与编译时异常

    1. 编译时异常

    在Java 中,Exception类中除了RuntimeException 类及其子类外都是编译时异常。编译时异常的特点是Java编译器会对其进行检查,如果出现异常就必须对异常进行处理,否则程序无法编译通过。

    处理方法

    使用try... catch 语句对异常进行捕获

    使用throws 关键字声明抛出异常,调用者对其进行处理

    2.运行时异常

    RuntimeException 类及其子类运行异常。运行时异常的特点是Java编译器不会对其进行检查。也就是说,当程序中出现这类异常时,即使没有使用try... catch 语句捕获使用throws关键字声明抛出。程序也能编译通过。运行时异常一般是程序中的逻辑错误引起的,在程序运行时无法修复。例如 数据取值越界。

    三 自定义异常

    JDK中定义了大量的异常类,虽然这些异常类可以描述编程时出现的大部分异常情况,但是在程序开发中有时可能需要描述程序中特有的异常情况。例如divide()方法中不允许被除数为负数。为类解决这个问题,在Java中允许用户自定义异常,但自定义的异常类必须继承自Exception或其子类。例子如下

    package www.kangxg.jdbc;

    public class DivideDivideByMinusException  extends Exception {

    /**

    *

    */

    private static final long serialVersionUID = 1L;

    public DivideDivideByMinusException(){

    super();

    }

    public DivideDivideByMinusException(String message)

    {

    super(message);

    }

    }

    package www.kangxg.jdbc;

    public class Example {

    public static void main(String[] args) throws Exception {

    try {

    int    result = divide(4,-2);

    System.out.println(result);

    } catch (DivideDivideByMinusException e) {

    System.out.println(e.getMessage());

    }

    }

    public static int divide(int x,int y) throws DivideDivideByMinusException

    {

    if(y<0)

    {

    throw new DivideDivideByMinusException("被除数是负数");

    }

    int result = x/y;

    return result;

    }

    }

    ————————————————

    版权声明:本文为CSDN博主「清雨未尽时」的原创文章,遵循 CC 4.0 BY-SA 版权协议,转载请附上原文出处链接及本声明。

    原文链接:https://blog.csdn.net/kangguang/article/details/79177336

    展开全文
  • 广告位API接口通信错误,查看德得广告获取帮助JAVA的throw和throws怎么用!throw是语句抛出一个异常;语法:throw(异常对象);扩展资料:throw与throws的区别1、throw用在方法体内,上面代码显示了,是直接在main方法...
  • 1、throws关键字通常被应用在声明方法时,用来指定可能抛出的异常。多个异常可以使用逗号隔开。当在主函数中调用该方法时,如果发生异常,就会将异常抛给指定异常对象。如下面例子所示:public class Shoot { 创建类...
  • java中内置了很多可能在编程时出现的大部分异常...3、如果在当前抛出异常的方法中处理异常,可以使用try-catch语句块捕捉并处理异常,否则在方法的声明处通过throws指明要抛出给方法调用者的异常,继续进行下一步操...
  • throws与throw的使用、try catch的使用
  • throw 和 throws 的区别

    2021-03-27 16:40:28
    在类和方法后面用throws,直接抛出异常就要用到throw。 throws就是放在类与方法后面,然后你要调用这个类与方法时,直接将类或方法抛出异常. throw就是单个语句抛出异常! throw是抛一个 throws是抛多个 这两者...
  • Java中throws..throw的使用与说明

    千次阅读 2021-03-09 01:58:46
    throws语句throws总是出现在一个函数头中,用来标明该成员函数可能抛出的各种异常。对大多数Exception子类来说,Java 编译器会强迫你声明在一个成员函数中抛出的异常的类型。如果异常的类型是Error或 ...
  • 在程序出现异常时,会有一个抛出异常的throw出现,这里我们要跟今天所讲的throws区分开。throws的作用是声明抛出,在名称上也跟throw有所不同。下面我们就throws对策概念、语法、实例带来讲解,帮助大家找到声明抛出...
  • 系统自动抛出的异常...语句抛出的异常用户程序自定义的异常和应用程序特定的异常,必须借助于 throws 和 throw 语句来定义抛出异常。throw是语句抛出一个异常。语法:throw (异常对象);throw e;throws是方法可能抛...
  • )throwsException放在方法后邊,是throwsException表示的是本方法不處理異常,交給被調用處處理(如果你不希望異常層層往上拋,你就要用throws Exception),而且被調用處必須處理。2、throw new Exception表示人為的...
  • Java throw和throws 关键字在本教程中,我们将在示例的帮助下学习使用throw和throws关键字进行异常处理。在Java中,异常可以分为两种类型:未检查的异常:它们不是在编译时而是在运行时被检查,例如:Arithmetic...
  • import java.io.File;import java.io.FileInputStream;.../** 异常处理的方式二:throws + 异常类型** 1. "throws + 异常类型"写在方法的声明处。指明此方法执行时,可能会抛出的异常类型。* 一旦当...
  • 方式一:throws 我们这里先用throws: 在parse处Alt+Enter,选择Add exception to method signature,会自动在main后面添加throws ParseException。代码变为: import java.text.ParseException; import java.text....
  • 什么时候在Java方法声明中使用throws?所以我认为我对Java中的exception处理有了很好的基本理解,但最近我正在阅读一些代码,这给我一些困惑和疑惑。 我主要怀疑的是,我想在这里介绍一个人应该在什么时候抛出Java...
  • throws和throw:throws:用来声明一个方法可能产生的所有异常,不做任何处理而是将异常往上传,谁调用我我就抛给谁。用在方法声明后面,跟的是异常类名可以跟多个异常类名,用逗号隔开表示抛出异常,由该方法的调用...
  • 通过throws抛出异常时,针对可能出现的多种异常情况,有以下两种解决方案: 方案一:throws后面接多个异常类型,中间用逗号分隔 package java_exception; import java.util.InputMismatchException; import java....
  • 考虑使用接口的代码:public function doSomething(MyInterface $my) { ......当然这并不意味着每个方法都应该有一个@throws被打了.它应该仍然只能在适当的地方使用(希望实现合法需要抛出异常的地方).作为一个更...
  • )throwsException放在方法后边,是throwsException表示的是本方法不处理异常,交给被调用处处理(如果你不希望异常层层往上抛,你就要用throws Exception),而且被调用处必须处理。2、throw new Exception表示人为的...
  • 本文实例讲述了Java异常处理与throws关键字用法。分享给大家供大家参考,具体如下:Java异常处理认识异常:1.异常是导致程序中断运行的一种指令流,如果不对异常进行正确处理,则可能导致程序的中断执行,造成不必要...
  • Java 中的异常处理除了包括捕获异常和处理异常之外,还包括声明异常和拋出异常,可以通过 throws 关键字在方法上声明该方法要拋出的异常,然后在方法内部通过 throw 拋出异常对象。本节详细介绍在 Java 中如何声明...
  • Java throws和throw:声明和抛出异常Java 中的异常处理除了捕获异常和处理异常之外,还包括声明异常和拋出异常。实现声明和抛出异常的关键字非常相似,它们是 throws 和 throw。可以通过 throws 关键字在方法上声明...
  • 容易记住访问修饰符可以从限制更改为限制更少,例如从受保护到公共,但反之亦然throws签名可以是从父异常更改为子异常类,但反之亦然此代码有效public class A {protected String foo() throws Exception{return "a...
  • 如果在当前方法不知道该如何处理该异常时,则可以使用throws对异常进行抛出给调用者处理或者交给JVM。JVM对异常的处理方式是:打印异常的跟踪栈信息并终止程序运行。 throws在使用时应处于方法签名之后使用,可以抛...
  • idea throws异常快捷键

    2021-04-25 18:42:20
    光标在改行上按 shift+alt+enter
  • 要解决此问题,您需要将导致异常的代码包装在try catch ot中,然后使用throws子句抛出异常。如果使用throws子句引发异常,它将被p [推迟到调用行,即示例importjava.io.File;importjava.io.FileNotFoundException;...

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 2,229,449
精华内容 891,779
关键字:

throws

友情链接: RevolutionLogger.zip